function CompareNorms
% Comparing the Frobenius norms of approximations with Explicit Euler,
% Implicit Euler, and Implicit Mid-point rule

% Set the matrix A, the intitial condition Y0, step size h, matrix H, and
% other values you might need

A = ...
Y0 = ...
H = ...
h = ...

% Allocate memory for results (||Y_k'HY_k-I||_F)
normexpleul = zeros(20, 1);
normimpleul = zeros(20, 1);
normimplmidp = zeros(20, 1);

for k = 1:20
	
    % In each step compute the steps using the explicit, implicit Euler and
    % implicit midpoint rule
    ...
    % Compute the norms of the required error
	normexpleul(k) = ...
	normimpleul(k) = ...
	normimplmidp(k) = ...
end


% Plotting the results

fprintf('Explicit Euler: %.2e\n', normexpleul(20));
fprintf('Implicit Euler: %.2e\n', normimpleul(20));
fprintf('Implicit mid-point: %.2e\n', normimplmidp(20));

figure
semilogy(1:20, normexpleul, 'bo-', 1:20, normimpleul, 'g.-', 1:20, normimplmidp, 'r^-')
xlabel('Iterations', 'FontSize', 14)
ylabel('$\Vert Y_{k}^\top H Y_{k}-H\Vert_F$', 'Interpreter', 'latex', 'FontSize', 14)
legend('explicit Euler', 'implicit Euler', 'implicit mid-point', 'Location', 'East')
